import wizard
import pooler

view1="""<?xml version="1.0"?>
<form string="Disapprove purchase requisition">
    <field name="reason"/>
</form>
"""

fields1={
    "reason":{
        "string": "Reason",
        "type": "char",
        "size": 128,
    }
}

class wiz(wizard.interface):
    def _check(self,cr,uid,data,context):
        pool=pooler.get_pool(cr.dbname)
        pr_id=data["id"]
        pr=pool.get("purchase.requisition").browse(cr,uid,pr_id)
        if not pr.can_approve:
            raise wizard.except_wizard(_('UserError'), _('You can not give disapproval for this purchase requisition'))
        return {}

    def _disapprove(self,cr,uid,data,context):
        pool=pooler.get_pool(cr.dbname)
        pr_id=data["id"]
        form=data["form"]
        reason=form["reason"]
        po=pool.get("purchase.requisition").browse(cr,uid,pr_id)
        pool.get("approvable").add_decision(cr,uid,pr.approvable_id.id,"disapprove")
        return {}

    states={
        "init":{
            "actions":[_check],
            "result":{
                "type":"form",
                "arch":view1,
                "fields":fields1,
                "state":[
                    ("disapprove","Disapprove"),
                    ("end","Cancel"),
                ]
            }
        },
        "disapprove":{
            "actions": [_disapprove],
            "result": {
                "type": "state",
                "state": "end",
            }
        },
    }
wiz("disapprove_pr")
